;	================================================================================
;	The image must be 32 bits. That means we have Alpha Channel, R, G and B in the same four bytes.
;	This effect gives more color to the image.
;	I made this effect from the GIMP. Except that for GIMP, Mask and Image are differents.
;	Here Mask and Image are the same. But The result is nice.

;	Args :
;		__lpBits		Pointer to the image bits
;		__dwImageSize	Size of the image in bytes

;	================================================================================

;	E = 1/255 x (M + I)

Effects_0303					PROC	USES EBX EDI ESI,__lpBits:LPBYTE,__dwImageSize:DWord
								LOCAL	_dw255:DWord
								LOCAL	_dwRed:DWord
								LOCAL	_dwGreen:DWord
								LOCAL	_dwBlue:DWord
								LOCAL	_d255:QWord

								mov		esi,__lpBits
								mov		ecx,__dwImageSize

								mov		DWord Ptr _dw255,255

								fld1
								fidiv	DWord Ptr _dw255
								fst		QWord Ptr _d255

@Loop :

								finit

								mov		eax,DWord Ptr [esi]
								mov		ebx,eax
								mov		edx,eax

								and		eax,000000ffh
								and		ebx,0000ff00h
								and		edx,00ff0000h

								shr		ebx,8
								shr		edx,16

								mov		_dwBlue,eax
								mov		_dwGreen,ebx
								mov		_dwRed,edx

								test	edx,edx
								jz		@F

								fild	DWord Ptr _dwRed
								fimul	DWord Ptr _dwRed
								fmul	QWord Ptr _d255
								fist	DWord Ptr _dwRed
								and		DWord Ptr _dwRed,000000ffh
								shl		DWord Ptr _dwRed,16

@@ :

								test	ebx,ebx
								jz		@F

								fild	DWord Ptr _dwGreen
								fimul	DWord Ptr _dwGreen
								fmul	QWord Ptr _d255
								fist	DWord Ptr _dwGreen
								and		DWord Ptr _dwGreen,000000ffh
								shl		DWord Ptr _dwGreen,8

@@ :

								test	eax,eax
								jz		@F

								fild	DWord Ptr _dwBlue
								fimul	DWord Ptr _dwBlue
								fmul	QWord Ptr _d255
								fist	DWord Ptr _dwBlue
								and		DWord Ptr _dwBlue,000000ffh

@@ :

								mov		eax,DWord Ptr _dwBlue
								or		eax,DWord Ptr _dwGreen
								or		eax,DWord Ptr _dwRed

								mov		DWord Ptr [esi],eax

								add		esi,SIZEOF DWord
								sub		ecx,SIZEOF DWord
								jnz		@Loop

@Exit :

								ret
Effects_0303					ENDP

